<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <div class="container">
    <div class="text-center mt-2 mb-2">
      <h2>F120 - Quản trị Order</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Loại Pizza</label>
        </div>
        <div class="col-sm-6">
          <select id="gPizzaTypeSelect" class="form-control">

          </select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-order" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>

    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="order-table">
        <thead>
          <tr>
            <th>STT</th>
            <th>Mã order</th>
            <th>Loại Pizza</th>
            <th>Tên khách hàng</th>
            <th>Ngày đặt hàng</th>
            <th>Trạng thái</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
    </div>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      // mảng orders
      var gOrderObjects = [
        {
          "id": 2,
          "orderCode": "12456",
          "gPizzaTypeId": 20,
          "customerName": "Do Van Linh",
          "date": "13/01/2021",
          "status": "completed"
        },
        {
          "id": 3,
          "orderCode": "22456",
          "gPizzaTypeId": 10,
          "customerName": "Huynh Van Nam",
          "date": "13/01/2021",
          "status": "new"
        },
        {
          "id": 4,
          "orderCode": "22986",
          "gPizzaTypeId": 15,
          "customerName": "Do Thi Lan",
          "date": "14/01/2021",
          "status": "completed"
        },
        {
          "id": 5,
          "orderCode": "42086",
          "gPizzaTypeId": 10,
          "customerName": "Dinh Chau Ngoc",
          "date": "14/01/2021",
          "status": "completed"
        },
        {
          "id": 6,
          "orderCode": "56086",
          "gPizzaTypeId": 15,
          "customerName": "Dang Tien Minh",
          "date": "15/01/2021",
          "status": "new"
        },
        {
          "id": 7,
          "orderCode": "90081",
          "gPizzaTypeId": 20,
          "customerName": "Do Hong Quan",
          "date": "15/01/2021",
          "status": "inprogress"
        },
        {
          "id": 8,
          "orderCode": "67012",
          "gPizzaTypeId": 15,
          "customerName": "Bui Thanh Phuoc",
          "date": "15/01/2021",
          "status": "inprogress"
        }
      ];

      // mảng pizza Type
      var gPizzaType = [
        {
          typeId: 10,
          typeName: "Hải Sản"
        },
        {
          typeId: 15,
          typeName: "Bò bít tết"
        },
        {
          typeId: 20,
          typeName: "Thịt gà"
        }
      ];
      const gARRAY_NAME_COL = ["id", "orderCode", "gPizzaTypeId", "customerName", "date", "status", "action"]

      const gID_COL = 0;
      const gORDER_CODE_COL = 1;
      const gPIZZA_TYPEID_COL = 2;
      const gCUSTOMER_NAME_COL = 3;
      const gDATE_COL = 4;
      const gSTATUS_COL = 5;
      const gACTION_COL = 6;
      var gSTT = 1
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      $("#btn-filter-order").on("click", function () {
        onBtnFilterClick()
      })
      onPageLoading();
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

      function onPageLoading() {
        $("#order-table").DataTable({
          data: gOrderObjects,
          columns: [
            { data: gARRAY_NAME_COL[gID_COL] },
            { data: gARRAY_NAME_COL[gORDER_CODE_COL] },
            { data: gARRAY_NAME_COL[gPIZZA_TYPEID_COL] },
            { data: gARRAY_NAME_COL[gCUSTOMER_NAME_COL] },
            { data: gARRAY_NAME_COL[gDATE_COL] },
            { data: gARRAY_NAME_COL[gSTATUS_COL] },
            { data: gARRAY_NAME_COL[gACTION_COL] },

          ],
          columnDefs: [
            {
              targets: gID_COL,
              className: "text-center",
              render: function (data) {
                return gSTT++;
              }
            },
            {
              targets: gACTION_COL,
              defaultContent:
                "<i style='cursor: pointer; color: blue' title='Edit' class='fas fa-edit fa-2x'></i>&nbsp; <i  style='cursor: pointer; color: red' title='Delete' class='fas fa-trash-alt fa-2x'></i> "
            }
          ]
        })
        loadDataToSelect(gPizzaType);
      }
      // hàm lọc dữ liệu
      function onBtnFilterClick() {
        //b0: Tạo đối tượng chứa điều kiện lọc
        var vFilterID = {
          pizzaTypeID: 0,
        }
        // B1: Thu thập dữ liệu
        getDataFromSelect(vFilterID);
        console.log(vFilterID)

        //B2: kiểm tra - bỏ qua
        //B3: Lọc dữ liệu
        var vResulFilter = filterData(vFilterID);
        console.log(vResulFilter);

        //B4: Hiển thị kết quả vào table
        displayDataToTable(vResulFilter);
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //B4: Hiển thị kết quả vào table
      function displayDataToTable(pagramData) {
        gSTT = 1;
        var vTable = $("#order-table").DataTable();
        vTable.clear();
        vTable.rows.add(pagramData);
        vTable.draw();
      }
      //-----------------------------------------------------
      // hàm lọc dữ liệu
      function filterData(pagramOjb) {
        var vResul = [];
        vResul = gOrderObjects.filter(function (item) {
          return (item.gPizzaTypeId == pagramOjb.pizzaTypeID || pagramOjb.pizzaTypeID == 0)
        })
        return vResul;
      }
      //------------------------------
      // hàm lọc dữ liệu
      function getDataFromSelect(pagramOjb) {
        var vPizzaOjb = $("#gPizzaTypeSelect").val();
        pagramOjb.pizzaTypeID = vPizzaOjb;
      }
      //----------------------------------------
      // hàm đổ dữ liện vào select
      function loadDataToSelect(pagram) {
        "use strict"
        $("#gPizzaTypeSelect")
          .append($("<option>", { value: 0, text: "-- Chọn Loại Pizza" }))

        for (var bI = 0; bI < pagram.length; bI++) {
          $("#gPizzaTypeSelect").append($("<option>", {
            value: pagram[bI].typeId,
            text: pagram[bI].typeName
          }))
        }
      }
      // hàm trả về pizzaTypeName dựa vào typeId

      function getPizzaNameByTypeId(paramTypeId) {
        "use strict";
        var vPizzaTypeName = "";
        var vIndex = 0;
        var vIsTypeFound = false;
        while (!vIsTypeFound && vIndex < gPizzaType.length) {
          if (gPizzaType[vIndex].typeId === paramTypeId) {
            vIsTypeFound = true;
            vPizzaTypeName = gPizzaType[vIndex].typeName;
          }
          else {
            vIndex++;
          }
        }
        return vPizzaTypeName;
      }

    </script>
</body>

</html>